# Dialog Manager

{% hint style="info" %}
**API SUBPATH**: eva-dialog-manager
{% endhint %}

## Flows

### Pagination and Listings

{% openapi src="<https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc>" path="/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows" method="get" %}
[eva-dialog-manager-4.7.0.yaml](https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media\&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc)
{% endopenapi %}

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/quicksearch

> Searches (greedily) for any flow names that exists in a bot,\
> matching the typed term, left-to-right, and returns a list of\
> up to 6 Strings, ordered alphabetically.<br>

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"flows","description":"Controller responsible for providing the services of listing, creating, updating and deleting flows."}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/quicksearch":{"get":{"tags":["flows"],"summary":"Searches (greedily) for any flow names that exists in a bot,\nmatching the typed term, left-to-right, and returns a list of\nup to 6 Strings, ordered alphabetically.\n","operationId":"quicksearch","parameters":[{"name":"x-request-id","in":"header","description":"It is an identifier provided by the API client that will be used to identify distributed logs.","required":false,"schema":{"type":"string"}},{"name":"orgUUID","in":"path","description":"It is the organization where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"It is the environment where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"It is the bot where the flow is, used to filter Flows","required":true,"schema":{"type":"string"}},{"name":"name","in":"query","description":"It is the parameter used to search for flows related to the entered value","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"uniqueItems":true,"type":"array","items":{"type":"string"}}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

### CRUD Operations

{% openapi src="<https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc>" path="/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows" method="post" %}
[eva-dialog-manager-4.7.0.yaml](https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media\&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc)
{% endopenapi %}

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/{uuid}

> Acquires complete, detailed information of a Flow

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"flows","description":"Controller responsible for providing the services of listing, creating, updating and deleting flows."}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/{uuid}":{"get":{"tags":["flows"],"summary":"Acquires complete, detailed information of a Flow","operationId":"findById","parameters":[{"name":"x-request-id","in":"header","description":"It is an identifier provided by the API client that will be used to identify distributed logs.","required":false,"schema":{"type":"string"}},{"name":"orgUUID","in":"path","description":"It is the organization where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"It is the environment where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"It is the bot where the flow is, used to filter Flows","required":true,"schema":{"type":"string"}},{"name":"uuid","in":"path","description":"It is the uuid used to search for a Flow","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"$ref":"#/components/schemas/FlowDTO"}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Resource not found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"FlowDTO":{"type":"object","properties":{"name":{"type":"string","description":"Name of the flow."},"description":{"type":"string","description":"Description of the flow."},"tags":{"uniqueItems":true,"type":"array","description":"These are the tags used in the Flow.","items":{"$ref":"#/components/schemas/TagDTO"}},"type":{"type":"string","description":"Enumeration of different flow types.","enum":["USER_JOURNEY","WELCOME","NOT_EXPECTED","JUMP","DRAFT","AGENTIC"]},"uuid":{"type":"string","description":"Uuid of the flow."},"createdBy":{"$ref":"#/components/schemas/UserDTO"},"rules":{"$ref":"#/components/schemas/RuleDTO"},"disconnected":{"type":"boolean","description":"It is a flag that represents if the Flow has disconnected cells."},"editors":{"type":"array","description":"It is a list of users who have already edited this Flow.","items":{"$ref":"#/components/schemas/UserDTO"}},"cellsType":{"type":"array","description":"It is a summary that contains the number of cell types in the Flow.","items":{"$ref":"#/components/schemas/CellTypeDTO"}},"jumpFrom":{"type":"object","description":"Contains data from cells that jump to this Flow."}},"description":"Contains the flow data used in load tree and editing service"},"TagDTO":{"type":"object","properties":{"name":{"type":"string","description":"Name of the Tag."}},"description":"Represents the tag data, used to reference the tags being used in the Flow."},"UserDTO":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the User."},"image":{"type":"string","description":"Image of the User."},"name":{"type":"string","description":"Name of the User."},"timeStamp":{"type":"integer","description":"Date of last edition of the Flow.","format":"int64"}},"description":" Represents the basic data of a User, in this case the last user to edit the Flow."},"RuleDTO":{"type":"object","properties":{"delete":{"type":"boolean","description":"Rule that representing whether a Flow can be deleted."},"jumped":{"type":"boolean","description":"Flag that indicates whether the flow is jumped."},"children":{"type":"array","description":"Type of cells that can start the flow.","items":{"type":"string","description":"Type of cells that can start the flow."}}},"description":"Represents the Flow rules, used to generate usage rules in Cockpit."},"CellTypeDTO":{"type":"object","properties":{"size":{"type":"integer","format":"int32"},"cellType":{"type":"string"},"names":{"type":"array","items":{"type":"string"}}},"description":"It is a summary that contains the number of cell types in the Flow."},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

{% openapi src="<https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc>" path="/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/{uuid}" method="put" %}
[eva-dialog-manager-4.7.0.yaml](https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media\&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc)
{% endopenapi %}

## DELETE /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/{uuid}

> Removes an existing flow.

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"flows","description":"Controller responsible for providing the services of listing, creating, updating and deleting flows."}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/{uuid}":{"delete":{"tags":["flows"],"summary":"Removes an existing flow.","operationId":"delete","parameters":[{"name":"x-request-id","in":"header","description":"It is an identifier provided by the API client that will be used to identify distributed logs.","required":false,"schema":{"type":"string"}},{"name":"orgUUID","in":"path","description":"It is the organization where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"It is the environment where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"It is the bot where the flow is, used to filter Flows","required":true,"schema":{"type":"string"}},{"name":"uuid","in":"path","description":"It is the uuid used to search for the Flow that will be deleted","required":true,"schema":{"type":"string"}}],"responses":{"204":{"description":"NO_CONTENT"},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

### Auxiliary Methods

{% openapi src="<https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc>" path="/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/types-to-create" method="get" %}
[eva-dialog-manager-4.7.0.yaml](https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media\&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc)
{% endopenapi %}

{% openapi src="<https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc>" path="/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/by-cellType" method="get" %}
[eva-dialog-manager-4.7.0.yaml](https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media\&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc)
{% endopenapi %}

### Flow Tree

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/{uuid}/tree

> Its function is to find the Flow data, containing the complete tree, rules and so on

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"flows","description":"Controller responsible for providing the services of listing, creating, updating and deleting flows."}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/flows/{uuid}/tree":{"get":{"tags":["flows"],"summary":"Its function is to find the Flow data, containing the complete tree, rules and so on","operationId":"findTree","parameters":[{"name":"x-request-id","in":"header","description":"It is an identifier provided by the API client that will be used to identify distributed logs.","required":false,"schema":{"type":"string"}},{"name":"orgUUID","in":"path","description":"It is the organization where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"It is the environment where the flow is, used to connect to the correct database","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"It is the bot where the flow is, used to filter Flows","required":true,"schema":{"type":"string"}},{"name":"uuid","in":"path","description":"It is the uuid used to search for a Flow","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"$ref":"#/components/schemas/TreeDTO"}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Resource not found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"TreeDTO":{"type":"object","properties":{"name":{"type":"string","description":"Name of the flow."},"description":{"type":"string","description":"Description of the flow."},"tags":{"uniqueItems":true,"type":"array","description":"These are the tags used in the Flow.","items":{"$ref":"#/components/schemas/TagDTO"}},"type":{"type":"string","description":"Enumeration of different flow types.","enum":["USER_JOURNEY","WELCOME","NOT_EXPECTED","JUMP","DRAFT","AGENTIC"]},"uuid":{"type":"string","description":"Uuid of the flow."},"createdBy":{"$ref":"#/components/schemas/UserDTO"},"rules":{"$ref":"#/components/schemas/RuleDTO"},"disconnected":{"type":"boolean","description":"It is a flag that represents if the Flow has disconnected cells."},"editors":{"type":"array","description":"It is a list of users who have already edited this Flow.","items":{"$ref":"#/components/schemas/UserDTO"}},"cellsType":{"type":"array","description":"It is a summary that contains the number of cell types in the Flow.","items":{"$ref":"#/components/schemas/CellTypeDTO"}},"jumpFrom":{"type":"object","description":"Contains data from cells that jump to this Flow."},"tree":{"$ref":"#/components/schemas/CellResponseDTO"}},"description":"Contains the flow complete data is used in request to load tree services"},"TagDTO":{"type":"object","properties":{"name":{"type":"string","description":"Name of the Tag."}},"description":"Represents the tag data, used to reference the tags being used in the Flow."},"UserDTO":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the User."},"image":{"type":"string","description":"Image of the User."},"name":{"type":"string","description":"Name of the User."},"timeStamp":{"type":"integer","description":"Date of last edition of the Flow.","format":"int64"}},"description":" Represents the basic data of a User, in this case the last user to edit the Flow."},"RuleDTO":{"type":"object","properties":{"delete":{"type":"boolean","description":"Rule that representing whether a Flow can be deleted."},"jumped":{"type":"boolean","description":"Flag that indicates whether the flow is jumped."},"children":{"type":"array","description":"Type of cells that can start the flow.","items":{"type":"string","description":"Type of cells that can start the flow."}}},"description":"Represents the Flow rules, used to generate usage rules in Cockpit."},"CellTypeDTO":{"type":"object","properties":{"size":{"type":"integer","format":"int32"},"cellType":{"type":"string"},"names":{"type":"array","items":{"type":"string"}}},"description":"It is a summary that contains the number of cell types in the Flow."},"CellResponseDTO":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the cell"},"cellFirst":{"type":"boolean","description":"True if is the first cell of flow, false if not"},"cellParentUUID":{"type":"string","description":"Uuid of parent cell"},"buttonParentUUID":{"type":"string","description":"Uuid of parent button"},"flowUUID":{"type":"string","description":"Uuid of flow that the cell belongs"},"draftText":{"type":"string","description":"Draft text of the cell"},"cellName":{"type":"string","description":"Name of the cell"},"cellType":{"type":"string","description":"Type of the cell"},"modelVersion":{"type":"string","description":"Model version of the cell"},"cellEnable":{"type":"boolean","description":"If the cell is enable or not"},"expressionCode":{"type":"string","description":"Expression code of the cell"},"objectRef":{"type":"string","description":"Uuid of the object that is relationed. This object can be intent, entity, service..."},"editor":{"$ref":"#/components/schemas/Editor"},"jumpTo":{"$ref":"#/components/schemas/JumpToResponseDTO"},"rules":{"$ref":"#/components/schemas/CellRulesDTO"},"disconnected":{"type":"boolean","description":"If the cell is disconnected or not"},"executionLimit":{"type":"integer","description":"Number of executions the cell may have","format":"int64"},"hasSibling":{"type":"boolean","description":"If the cell has siblings or not"},"jumpFrom":{"type":"array","description":"cell list coming to her from a jump cell","items":{"$ref":"#/components/schemas/JumpFromDTO"}},"tags":{"type":"array","description":"Tags of the cell","items":{"$ref":"#/components/schemas/Tag"}},"children":{"type":"array","description":"Children of the cell","items":{"$ref":"#/components/schemas/CellResponseDTO"}},"options":{"type":"array","description":"Buttons of the cell. It only has if it is a service type","items":{"$ref":"#/components/schemas/ButtonDTO"}},"description":{"type":"string","description":"Description of the cell"},"template":{"type":"string","description":"Template of the cell. It only has if it is a code or rule type"},"persona":{"$ref":"#/components/schemas/PersonaDTO"}},"description":"DTO responsible to return data of cell"},"Editor":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the editor"},"lastModified":{"type":"boolean","description":"If is last modified"},"lastEdition":{"type":"integer","description":"Timestamp of last edition","format":"int64"}},"description":"This class represents the eva users who modified the flow."},"JumpToResponseDTO":{"type":"object","properties":{"cellDestination":{"type":"string","description":"Uuid of destination cell"},"cellDestinationName":{"type":"string","description":"Name of destination cell"},"flowDestination":{"type":"string","description":"Uuid of destination flow"},"flowDestinationName":{"type":"string","description":"Name of destination flow"}},"description":"DTO with data about destination after jump"},"CellRulesDTO":{"type":"object","properties":{"connectionOnTheLeft":{"type":"boolean","description":"If the cell can be connected in the left"},"connectionOnTheRight":{"type":"boolean","description":"If the cell can be connected in the right"},"connectionOnTheBottom":{"type":"boolean","description":"If the cell can be connected in the bottom"},"delete":{"type":"boolean","description":"If the cell can be deleted"},"children":{"type":"array","description":"Cell type that can be children","items":{"type":"string","description":"Cell type that can be children"}},"sequence":{"type":"array","description":"Cell type that can be sequence","items":{"type":"string","description":"Cell type that can be sequence"}},"jump":{"type":"array","description":"Cell type that can jump to","items":{"type":"string","description":"Cell type that can jump to"}}},"description":"DTO responsible to return rules of cell"},"JumpFromDTO":{"type":"object","properties":{"cellOrigin":{"type":"string","description":"Uuid of origin cell"},"flowOrigin":{"type":"string","description":"Uuid of origin flow"}},"description":"DTO with data about cells that jump to this cell"},"Tag":{"type":"object","properties":{"name":{"type":"string"},"objectRef":{"type":"string"},"tagTypeId":{"type":"integer","format":"int32"}},"description":"Tags of the cell"},"ButtonDTO":{"type":"object","properties":{"buttonUUID":{"type":"string","description":"Uuid of the button"},"cockpitUUID":{"type":"string","description":"Uuid of the cockpit"},"urlRedirect":{"type":"boolean","description":"Url redirect"},"buttonUrl":{"type":"string","description":"Button url"},"buttonType":{"type":"string","description":"Type of the button"},"buttonText":{"type":"string","description":"Text of the button"},"expressionCode":{"type":"string","description":"Expression code of the button"},"connectedTo":{"type":"string","description":"Uuid of the cell where button is connected"},"disconnected":{"type":"boolean","description":"If button is disconnected or not"},"rules":{"$ref":"#/components/schemas/OptionRulesDTO"}},"description":"DTO with data about button"},"OptionRulesDTO":{"type":"object","properties":{"connectionOnTheLeft":{"type":"boolean","description":"If the cell can be connected in the left"},"connectionOnTheRight":{"type":"boolean","description":"If the cell can be connected in the right"},"connectionOnTheBottom":{"type":"boolean","description":"If the cell can be connected in the bottom"},"children":{"type":"array","description":"Cell type that can be children","items":{"type":"string","description":"Cell type that can be children"}},"sequence":{"type":"array","description":"Cell type that can be sequence","items":{"type":"string","description":"Cell type that can be sequence"}}},"description":"DTO responsible to return rules of button"},"PersonaDTO":{"type":"object","properties":{"persona":{"type":"string","description":"The name of the person"},"iconUrl":{"type":"string","description":"URL of the person's icon"}},"description":"Data Transfer Object for a person"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## Cells

### CRUD Operations

## POST /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells

> Create new cells

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells":{"post":{"tags":["cells"],"summary":"Create new cells","operationId":"insert","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"flowUUID","in":"query","description":"Uuid flow to insert the new cell","required":true,"schema":{"type":"string"}},{"name":"cellParentUUID","in":"query","description":"Uuid of the parent cell. Necessary if it is not the first cell of flow","required":false,"schema":{"type":"string"}},{"name":"buttonUUID","in":"query","description":"Uuid of the button. Necessary if it's a service cell parent","required":false,"schema":{"type":"string","default":""}},{"name":"action","in":"query","description":"Type of insertion","required":false,"schema":{"type":"string","enum":["SEQUENCE","CHILDREN"],"default":"CHILDREN"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CellCreateDTO"}}},"required":true},"responses":{"201":{"description":"Created","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/CellResponseDTO"}}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"CellCreateDTO":{"required":["cellName","cellType","expressionCode"],"type":"object","properties":{"cellName":{"type":"string","description":"Name of the cell"},"cellType":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"]},"description":{"type":"string","description":"Description of the cell"},"objectRef":{"type":"string","description":"Uuid of object to relationate. It can be intent, entity, service..."},"expressionCode":{"type":"string","description":"Expression code of the cell"},"jumpTo":{"$ref":"#/components/schemas/JumpTo"},"template":{"type":"string","description":"Template of the cell. It's required if cell is code or rule type"},"executionLimit":{"type":"integer","description":"Number of times that the cell has to execute repeatedly","format":"int64"},"options":{"type":"array","description":"Options of the cell. It's required if cell is service type","items":{"$ref":"#/components/schemas/ButtonCreateDTO"}},"tags":{"type":"array","description":"Tags of the cell","items":{"$ref":"#/components/schemas/Tag"}},"icon":{"type":"string","description":"Icon associated with the cell"},"persona":{"type":"string","description":"Persona associated with the cell"}},"description":"A body containing all necessary data to create a new cell"},"JumpTo":{"type":"object","properties":{"cellDestination":{"type":"string","description":"Uuid of destination cell. It's required cell or flow destination"},"flowDestination":{"type":"string","description":"Uuid of destination flow. It's required cell or flow destination"}},"description":"DTO and entity used to request create of jump cell"},"ButtonCreateDTO":{"required":["buttonText","buttonType"],"type":"object","properties":{"cockpitUUID":{"type":"string","description":"This uuid will be the equals for every same button of the service"},"urlRedirect":{"type":"boolean","description":"True if has url redirect and false if not"},"buttonUrl":{"type":"string","description":"Url of button"},"buttonType":{"type":"string","description":"Type of button"},"buttonText":{"type":"string","description":"Text of button"}},"description":"DTO used to request create cell with buttons"},"Tag":{"type":"object","properties":{"name":{"type":"string"},"objectRef":{"type":"string"},"tagTypeId":{"type":"integer","format":"int32"}},"description":"Tags of the cell"},"CellResponseDTO":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the cell"},"cellFirst":{"type":"boolean","description":"True if is the first cell of flow, false if not"},"cellParentUUID":{"type":"string","description":"Uuid of parent cell"},"buttonParentUUID":{"type":"string","description":"Uuid of parent button"},"flowUUID":{"type":"string","description":"Uuid of flow that the cell belongs"},"draftText":{"type":"string","description":"Draft text of the cell"},"cellName":{"type":"string","description":"Name of the cell"},"cellType":{"type":"string","description":"Type of the cell"},"modelVersion":{"type":"string","description":"Model version of the cell"},"cellEnable":{"type":"boolean","description":"If the cell is enable or not"},"expressionCode":{"type":"string","description":"Expression code of the cell"},"objectRef":{"type":"string","description":"Uuid of the object that is relationed. This object can be intent, entity, service..."},"editor":{"$ref":"#/components/schemas/Editor"},"jumpTo":{"$ref":"#/components/schemas/JumpToResponseDTO"},"rules":{"$ref":"#/components/schemas/CellRulesDTO"},"disconnected":{"type":"boolean","description":"If the cell is disconnected or not"},"executionLimit":{"type":"integer","description":"Number of executions the cell may have","format":"int64"},"hasSibling":{"type":"boolean","description":"If the cell has siblings or not"},"jumpFrom":{"type":"array","description":"cell list coming to her from a jump cell","items":{"$ref":"#/components/schemas/JumpFromDTO"}},"tags":{"type":"array","description":"Tags of the cell","items":{"$ref":"#/components/schemas/Tag"}},"children":{"type":"array","description":"Children of the cell","items":{"$ref":"#/components/schemas/CellResponseDTO"}},"options":{"type":"array","description":"Buttons of the cell. It only has if it is a service type","items":{"$ref":"#/components/schemas/ButtonDTO"}},"description":{"type":"string","description":"Description of the cell"},"template":{"type":"string","description":"Template of the cell. It only has if it is a code or rule type"},"persona":{"$ref":"#/components/schemas/PersonaDTO"}},"description":"DTO responsible to return data of cell"},"Editor":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the editor"},"lastModified":{"type":"boolean","description":"If is last modified"},"lastEdition":{"type":"integer","description":"Timestamp of last edition","format":"int64"}},"description":"This class represents the eva users who modified the flow."},"JumpToResponseDTO":{"type":"object","properties":{"cellDestination":{"type":"string","description":"Uuid of destination cell"},"cellDestinationName":{"type":"string","description":"Name of destination cell"},"flowDestination":{"type":"string","description":"Uuid of destination flow"},"flowDestinationName":{"type":"string","description":"Name of destination flow"}},"description":"DTO with data about destination after jump"},"CellRulesDTO":{"type":"object","properties":{"connectionOnTheLeft":{"type":"boolean","description":"If the cell can be connected in the left"},"connectionOnTheRight":{"type":"boolean","description":"If the cell can be connected in the right"},"connectionOnTheBottom":{"type":"boolean","description":"If the cell can be connected in the bottom"},"delete":{"type":"boolean","description":"If the cell can be deleted"},"children":{"type":"array","description":"Cell type that can be children","items":{"type":"string","description":"Cell type that can be children"}},"sequence":{"type":"array","description":"Cell type that can be sequence","items":{"type":"string","description":"Cell type that can be sequence"}},"jump":{"type":"array","description":"Cell type that can jump to","items":{"type":"string","description":"Cell type that can jump to"}}},"description":"DTO responsible to return rules of cell"},"JumpFromDTO":{"type":"object","properties":{"cellOrigin":{"type":"string","description":"Uuid of origin cell"},"flowOrigin":{"type":"string","description":"Uuid of origin flow"}},"description":"DTO with data about cells that jump to this cell"},"ButtonDTO":{"type":"object","properties":{"buttonUUID":{"type":"string","description":"Uuid of the button"},"cockpitUUID":{"type":"string","description":"Uuid of the cockpit"},"urlRedirect":{"type":"boolean","description":"Url redirect"},"buttonUrl":{"type":"string","description":"Button url"},"buttonType":{"type":"string","description":"Type of the button"},"buttonText":{"type":"string","description":"Text of the button"},"expressionCode":{"type":"string","description":"Expression code of the button"},"connectedTo":{"type":"string","description":"Uuid of the cell where button is connected"},"disconnected":{"type":"boolean","description":"If button is disconnected or not"},"rules":{"$ref":"#/components/schemas/OptionRulesDTO"}},"description":"DTO with data about button"},"OptionRulesDTO":{"type":"object","properties":{"connectionOnTheLeft":{"type":"boolean","description":"If the cell can be connected in the left"},"connectionOnTheRight":{"type":"boolean","description":"If the cell can be connected in the right"},"connectionOnTheBottom":{"type":"boolean","description":"If the cell can be connected in the bottom"},"children":{"type":"array","description":"Cell type that can be children","items":{"type":"string","description":"Cell type that can be children"}},"sequence":{"type":"array","description":"Cell type that can be sequence","items":{"type":"string","description":"Cell type that can be sequence"}}},"description":"DTO responsible to return rules of button"},"PersonaDTO":{"type":"object","properties":{"persona":{"type":"string","description":"The name of the person"},"iconUrl":{"type":"string","description":"URL of the person's icon"}},"description":"Data Transfer Object for a person"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/{cellUUID}

> Retrieves detailed information of a Cell.

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/{cellUUID}":{"get":{"tags":["cells"],"summary":"Retrieves detailed information of a Cell.","operationId":"fetch","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellUUID","in":"path","description":"A valid cell Uuid","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"$ref":"#/components/schemas/CellResponseDTO"}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"CellResponseDTO":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the cell"},"cellFirst":{"type":"boolean","description":"True if is the first cell of flow, false if not"},"cellParentUUID":{"type":"string","description":"Uuid of parent cell"},"buttonParentUUID":{"type":"string","description":"Uuid of parent button"},"flowUUID":{"type":"string","description":"Uuid of flow that the cell belongs"},"draftText":{"type":"string","description":"Draft text of the cell"},"cellName":{"type":"string","description":"Name of the cell"},"cellType":{"type":"string","description":"Type of the cell"},"modelVersion":{"type":"string","description":"Model version of the cell"},"cellEnable":{"type":"boolean","description":"If the cell is enable or not"},"expressionCode":{"type":"string","description":"Expression code of the cell"},"objectRef":{"type":"string","description":"Uuid of the object that is relationed. This object can be intent, entity, service..."},"editor":{"$ref":"#/components/schemas/Editor"},"jumpTo":{"$ref":"#/components/schemas/JumpToResponseDTO"},"rules":{"$ref":"#/components/schemas/CellRulesDTO"},"disconnected":{"type":"boolean","description":"If the cell is disconnected or not"},"executionLimit":{"type":"integer","description":"Number of executions the cell may have","format":"int64"},"hasSibling":{"type":"boolean","description":"If the cell has siblings or not"},"jumpFrom":{"type":"array","description":"cell list coming to her from a jump cell","items":{"$ref":"#/components/schemas/JumpFromDTO"}},"tags":{"type":"array","description":"Tags of the cell","items":{"$ref":"#/components/schemas/Tag"}},"children":{"type":"array","description":"Children of the cell","items":{"$ref":"#/components/schemas/CellResponseDTO"}},"options":{"type":"array","description":"Buttons of the cell. It only has if it is a service type","items":{"$ref":"#/components/schemas/ButtonDTO"}},"description":{"type":"string","description":"Description of the cell"},"template":{"type":"string","description":"Template of the cell. It only has if it is a code or rule type"},"persona":{"$ref":"#/components/schemas/PersonaDTO"}},"description":"DTO responsible to return data of cell"},"Editor":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the editor"},"lastModified":{"type":"boolean","description":"If is last modified"},"lastEdition":{"type":"integer","description":"Timestamp of last edition","format":"int64"}},"description":"This class represents the eva users who modified the flow."},"JumpToResponseDTO":{"type":"object","properties":{"cellDestination":{"type":"string","description":"Uuid of destination cell"},"cellDestinationName":{"type":"string","description":"Name of destination cell"},"flowDestination":{"type":"string","description":"Uuid of destination flow"},"flowDestinationName":{"type":"string","description":"Name of destination flow"}},"description":"DTO with data about destination after jump"},"CellRulesDTO":{"type":"object","properties":{"connectionOnTheLeft":{"type":"boolean","description":"If the cell can be connected in the left"},"connectionOnTheRight":{"type":"boolean","description":"If the cell can be connected in the right"},"connectionOnTheBottom":{"type":"boolean","description":"If the cell can be connected in the bottom"},"delete":{"type":"boolean","description":"If the cell can be deleted"},"children":{"type":"array","description":"Cell type that can be children","items":{"type":"string","description":"Cell type that can be children"}},"sequence":{"type":"array","description":"Cell type that can be sequence","items":{"type":"string","description":"Cell type that can be sequence"}},"jump":{"type":"array","description":"Cell type that can jump to","items":{"type":"string","description":"Cell type that can jump to"}}},"description":"DTO responsible to return rules of cell"},"JumpFromDTO":{"type":"object","properties":{"cellOrigin":{"type":"string","description":"Uuid of origin cell"},"flowOrigin":{"type":"string","description":"Uuid of origin flow"}},"description":"DTO with data about cells that jump to this cell"},"Tag":{"type":"object","properties":{"name":{"type":"string"},"objectRef":{"type":"string"},"tagTypeId":{"type":"integer","format":"int32"}},"description":"Tags of the cell"},"ButtonDTO":{"type":"object","properties":{"buttonUUID":{"type":"string","description":"Uuid of the button"},"cockpitUUID":{"type":"string","description":"Uuid of the cockpit"},"urlRedirect":{"type":"boolean","description":"Url redirect"},"buttonUrl":{"type":"string","description":"Button url"},"buttonType":{"type":"string","description":"Type of the button"},"buttonText":{"type":"string","description":"Text of the button"},"expressionCode":{"type":"string","description":"Expression code of the button"},"connectedTo":{"type":"string","description":"Uuid of the cell where button is connected"},"disconnected":{"type":"boolean","description":"If button is disconnected or not"},"rules":{"$ref":"#/components/schemas/OptionRulesDTO"}},"description":"DTO with data about button"},"OptionRulesDTO":{"type":"object","properties":{"connectionOnTheLeft":{"type":"boolean","description":"If the cell can be connected in the left"},"connectionOnTheRight":{"type":"boolean","description":"If the cell can be connected in the right"},"connectionOnTheBottom":{"type":"boolean","description":"If the cell can be connected in the bottom"},"children":{"type":"array","description":"Cell type that can be children","items":{"type":"string","description":"Cell type that can be children"}},"sequence":{"type":"array","description":"Cell type that can be sequence","items":{"type":"string","description":"Cell type that can be sequence"}}},"description":"DTO responsible to return rules of button"},"PersonaDTO":{"type":"object","properties":{"persona":{"type":"string","description":"The name of the person"},"iconUrl":{"type":"string","description":"URL of the person's icon"}},"description":"Data Transfer Object for a person"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## PUT /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/{cellUUID}

> Updates an existing Cell.

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/{cellUUID}":{"put":{"tags":["cells"],"summary":"Updates an existing Cell.","operationId":"update_1","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellUUID","in":"path","description":"A valid cell Uuid","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CellUpdateDTO"}}},"required":true},"responses":{"204":{"description":"No Content"},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"CellUpdateDTO":{"required":["cellEnable","cellName","expressionCode"],"type":"object","properties":{"cellName":{"type":"string","description":"Name of the cell"},"description":{"type":"string","description":"Description of the cell"},"objectRef":{"type":"string","description":"Uuid of object to relationate. It can be intent, entity, service..."},"expressionCode":{"type":"string","description":"Expression code of the cell"},"cellEnable":{"type":"boolean","description":"True if wants to enable cell or false if not"},"jumpTo":{"$ref":"#/components/schemas/JumpTo"},"template":{"type":"string","description":"Template of the cell. It's required if cell is code or rule type"},"executionLimit":{"type":"integer","description":"Number of times that the cell has to execute repeatedly","format":"int64"},"options":{"type":"array","description":"Options of the cell. It's required if cell is service type","items":{"$ref":"#/components/schemas/ButtonUpdateDTO"}},"tags":{"type":"array","description":"Tags of the cell","items":{"$ref":"#/components/schemas/Tag"}},"icon":{"type":"string","description":"Icon of the cell"},"persona":{"type":"string","description":"Persona of the cell"}},"description":"A body containing all necessary data to update cell"},"JumpTo":{"type":"object","properties":{"cellDestination":{"type":"string","description":"Uuid of destination cell. It's required cell or flow destination"},"flowDestination":{"type":"string","description":"Uuid of destination flow. It's required cell or flow destination"}},"description":"DTO and entity used to request create of jump cell"},"ButtonUpdateDTO":{"required":["buttonText","buttonType","buttonUrl","cockpitUUID","urlRedirect"],"type":"object","properties":{"cockpitUUID":{"type":"string","description":"Uuid of button of cockpit"},"urlRedirect":{"type":"boolean","description":"True if has url redirect and false if not"},"buttonUrl":{"type":"string","description":"Url of button"},"buttonType":{"type":"string","description":"Type of button"},"buttonText":{"type":"string","description":"Text of button"}},"description":"DTO used to request create cell with buttons"},"Tag":{"type":"object","properties":{"name":{"type":"string"},"objectRef":{"type":"string"},"tagTypeId":{"type":"integer","format":"int32"}},"description":"Tags of the cell"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## DELETE /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/{cellUUID}

> Removes an existing Cell.

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/{cellUUID}":{"delete":{"tags":["cells"],"summary":"Removes an existing Cell.","operationId":"remove","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellUUID","in":"path","description":"A valid cell Uuid","required":true,"schema":{"type":"string"}},{"name":"deleteInCascade","in":"query","description":"True if wants to delete all children of the cell. False if wants to delete only the cell and converting it to Placeholder type","required":false,"schema":{"type":"boolean","default":true}}],"responses":{"204":{"description":"No Content"},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

### Auxiliary Methods

## POST /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/template/validate

> Valid the template of cell

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/template/validate":{"post":{"tags":["cells"],"summary":"Valid the template of cell","operationId":"templateValidate","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellType","in":"query","description":"Type of cell to list","required":true,"schema":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"]}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/TemplateDTO"}}},"required":true},"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"$ref":"#/components/schemas/TemplateResponseDTO"}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"TemplateDTO":{"type":"object","properties":{"template":{"type":"string"}},"description":"DTO with the template of cell to valid"},"TemplateResponseDTO":{"type":"object","properties":{"valid":{"type":"boolean","description":"If it's valid or not"},"message":{"type":"string","description":"Message if it's not valid"}},"description":"DTO responsible to return if template is valid or not"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/by-type

> List all cells of a bot by the type passed in parameter

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/by-type":{"get":{"tags":["cells"],"summary":"List all cells of a bot by the type passed in parameter","operationId":"listAllCellsOfBotByCellType","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellType","in":"query","description":"Type of cell to list","required":true,"schema":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"]}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ObjectCellDTO"}}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"ObjectCellDTO":{"type":"object","properties":{"objectRef":{"type":"string","description":"Uuid of the object that is relationed. This object can be intent, entity, service..."},"cellType":{"type":"string","description":"Type of cell"}},"description":"DTO user to response cells of a bot by the type"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/start-flows

> List all objectRef of cells that are the first cell of any flow in one bot

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/start-flows":{"get":{"tags":["cells"],"summary":"List all objectRef of cells that are the first cell of any flow in one bot","operationId":"findAllObjectRefFirstCellsByCellType","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellType","in":"query","description":"Type of cell to list","required":true,"schema":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"]}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"type":"array","items":{"type":"string"}}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/buttons

> List all buttons of service cell

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/buttons":{"get":{"tags":["cells"],"summary":"List all buttons of service cell","operationId":"findButtonsOfCellTypeByObjectRef","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellType","in":"query","description":"Type of cell to list","required":true,"schema":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"]}},{"name":"objectRef","in":"query","description":"Id of the object intent, entity, service...","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/Button"}}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"Button":{"type":"object","properties":{"buttonUUID":{"type":"string","description":"Uuid of button"},"cockpitUUID":{"type":"string","description":"Uuid of button of cockpit"},"urlRedirect":{"type":"boolean","description":"True if has url redirect and false if not"},"buttonUrl":{"type":"string","description":"Url of button"},"buttonType":{"type":"string","description":"Type of button"},"buttonText":{"type":"string","description":"Text of button"},"expressionCode":{"type":"string","description":"Expression code of button"},"connectedTo":{"type":"string","description":"Uuid of the cell connected in the button"}},"description":"Data of options of service cell"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/connection

> List all cells informing if can be connected left, bottom or right

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/connection":{"get":{"tags":["cells"],"summary":"List all cells informing if can be connected left, bottom or right","operationId":"possibleConnections","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"uuid","in":"query","description":"A valid cell Uuid","required":true,"schema":{"type":"string"}},{"name":"direction","in":"query","description":"Direction that wants to know the possible connections. It can be left, bottom or right","required":true,"schema":{"type":"string","enum":["LEFT","RIGHT","BOTTOM"]}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/ConnectionCellDTO"}}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"ConnectionCellDTO":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the cell"},"connectionOnTheLeft":{"type":"boolean","description":"If can be connected in left"},"connectionOnTheRight":{"type":"boolean","description":"If can be connected in right"},"connectionOnTheBottom":{"type":"boolean","description":"If can be connected in bottom"}},"description":"DTO responsible to return connections of cells"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## GET /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/jump

> List all flows that is possible to jump

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/jump":{"get":{"tags":["cells"],"summary":"List all flows that is possible to jump","operationId":"possibleFlowsToJump","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"flowUUID","in":"query","description":"A valid flow Uuid","required":true,"schema":{"type":"string"}},{"name":"cellParentUUID","in":"query","description":"Uuid of the parent cell","required":true,"schema":{"type":"string"}},{"name":"action","in":"query","description":"Type of insertion","required":false,"schema":{"type":"string","enum":["SEQUENCE","CHILDREN"],"default":"CHILDREN"}},{"name":"cellType","in":"query","description":"Type of cell","required":false,"schema":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"],"default":"JUMP"}}],"responses":{"200":{"description":"Ok","content":{"*/*":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/PossibleFlowDTO"}}}}},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"PossibleFlowDTO":{"type":"object","properties":{"uuid":{"type":"string","description":"Uuid of the flow"},"name":{"type":"string","description":"Name of the flow"},"type":{"type":"string","description":"Enumeration of different flow types.","enum":["USER_JOURNEY","WELCOME","NOT_EXPECTED","JUMP","DRAFT","AGENTIC"]},"enabled":{"type":"boolean","description":"True if it's possible to jump, false if not"},"error":{"type":"string","description":"If it's false, it's the message saying why you can't jump"}},"description":"Possible flows to jump with uuid, name, type, if is enabled or not and why is disabled"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## PUT /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/massive

> Massive update

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/massive":{"put":{"tags":["cells"],"summary":"Massive update","operationId":"massiveUpdate","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellType","in":"query","description":"Type of cell to update","required":true,"schema":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"]}},{"name":"objectRef","in":"query","description":"Id of the object (intent, entity, service...","required":true,"schema":{"type":"string"}}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/CellUpdateMassiveDTO"}}},"required":true},"responses":{"204":{"description":"No Content"},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"CellUpdateMassiveDTO":{"required":["cellEnable","cellName","expressionCode"],"type":"object","properties":{"cellName":{"type":"string","description":"Name of the cell"},"description":{"type":"string","description":"Description of the cell"},"expressionCode":{"type":"string","description":"Expression code of the cell"},"cellEnable":{"type":"boolean","description":"True if wants to enable cell or false if not"},"executionLimit":{"type":"integer","description":"Number of times that the cell has to execute repeatedly","format":"int64"},"options":{"type":"array","description":"Options of the cell. It's required if cell is service type","items":{"$ref":"#/components/schemas/ButtonUpdateDTO"}},"template":{"type":"string","description":"Template of the cell, in this case is used to rest connector cell"},"tags":{"type":"array","description":"Tags of the cell","items":{"$ref":"#/components/schemas/Tag"}},"icon":{"type":"string","description":"Icon of the cell"},"persona":{"type":"string","description":"Persona of the cell"}},"description":"A body containing all necessary data to update cells"},"ButtonUpdateDTO":{"required":["buttonText","buttonType","buttonUrl","cockpitUUID","urlRedirect"],"type":"object","properties":{"cockpitUUID":{"type":"string","description":"Uuid of button of cockpit"},"urlRedirect":{"type":"boolean","description":"True if has url redirect and false if not"},"buttonUrl":{"type":"string","description":"Url of button"},"buttonType":{"type":"string","description":"Type of button"},"buttonText":{"type":"string","description":"Text of button"}},"description":"DTO used to request create cell with buttons"},"Tag":{"type":"object","properties":{"name":{"type":"string"},"objectRef":{"type":"string"},"tagTypeId":{"type":"integer","format":"int32"}},"description":"Tags of the cell"},"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

## PUT /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/connection

> Estabilishes a sequential connection between two existing cells.

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/connection":{"put":{"tags":["cells"],"summary":"Estabilishes a sequential connection between two existing cells.","operationId":"connectionCells","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellOrigin","in":"query","description":"UUID of origin cell to connect","required":true,"schema":{"type":"string"}},{"name":"cellDestination","in":"query","description":"UUID of destination cell to connect","required":true,"schema":{"type":"string"}},{"name":"buttonUUID","in":"query","description":"UUID of button to connect if is service cell","required":true,"schema":{"type":"string","default":""}},{"name":"direction","in":"query","description":"Direction that wants to know the possible connections. It can be left, bottom or right","required":true,"schema":{"type":"string","enum":["LEFT","RIGHT","BOTTOM"]}}],"responses":{"204":{"description":"No Content"},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```

{% openapi src="<https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc>" path="/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/change-visibility" method="put" %}
[eva-dialog-manager-4.7.0.yaml](https://4008706377-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2Fn6zS4HeuuVpRHZEvDiFU%2Fuploads%2F1MWzLX4hdupDD3EJR4rV%2Feva-dialog-manager-4.7.0.yaml?alt=media\&token=74e7e5bc-10ef-4195-bbb7-7d8a192ccfcc)
{% endopenapi %}

## DELETE /org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/by-type

> Remove cells by its type

```json
{"openapi":"3.0.1","info":{"title":"eva-dialog-manager API Documentation","version":"4.8.0"},"tags":[{"name":"cells","description":"Management for creating, listing, finding, updating and deleting cells"}],"paths":{"/org/{orgUUID}/env/{envUUID}/bot/{botUUID}/cells/by-type":{"delete":{"tags":["cells"],"summary":"Remove cells by its type","operationId":"removeByCellType","parameters":[{"name":"orgUUID","in":"path","description":"A valid organization Uuid","required":true,"schema":{"type":"string"}},{"name":"envUUID","in":"path","description":"A valid environment Uuid","required":true,"schema":{"type":"string"}},{"name":"botUUID","in":"path","description":"A valid bot Uuid","required":true,"schema":{"type":"string"}},{"name":"cellType","in":"query","description":"Type of cell to remove","required":true,"schema":{"type":"string","description":"Enumeration of cell types.","enum":["ANSWER","ANYTHING_ELSE","INTENT","ENTITY","SYSTEM_ENTITY","SERVICE","GENERATIVE_SERVICE","REST","USER","BOT","JUMP","WAIT_INPUT","RULE","CODE","PLACE_HOLDER","END","START","AGENT","TRANSFER"]}},{"name":"objectRef","in":"query","description":"Id of the object (intent, entity, service...","required":true,"schema":{"type":"string"}},{"name":"deleteInCascade","in":"query","description":"True if wants to delete all children of the cell. False if wants to delete only the cell and converting it to Placeholder type","required":false,"schema":{"type":"boolean","default":false}}],"responses":{"204":{"description":"No Content"},"400":{"description":"Bad Request","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"401":{"description":"Unauthorized","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"403":{"description":"Forbidden","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"404":{"description":"Not Found","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"408":{"description":"Request Timeout","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"409":{"description":"Conflict","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}},"422":{"description":"Unprocessable Entity","content":{"*/*":{"schema":{"oneOf":[{"$ref":"#/components/schemas/ValidationError"},{"$ref":"#/components/schemas/StandardError"}]}}}},"500":{"description":"Internal Server Error","content":{"*/*":{"schema":{"$ref":"#/components/schemas/StandardError"}}}}}}}},"components":{"schemas":{"StandardError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"}}},"ValidationError":{"type":"object","properties":{"timestamp":{"type":"integer","format":"int64"},"errorCode":{"type":"string"},"errorType":{"type":"string","enum":["API_ERROR","API_INFO","USER_ERROR"]},"message":{"type":"string"},"path":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/FieldMessage"}}}},"FieldMessage":{"type":"object","properties":{"fieldName":{"type":"string"},"message":{"type":"string"},"errorCode":{"type":"string"}}}}}}
```
